﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.WebSockets;
using System.Text;
using System.Threading.Tasks;

namespace RcpServer
{
    public class Server
    {
        public Server(string uriPrefix)
        {
            _httpListener = new HttpListener();
            _httpListener.Prefixes.Add(uriPrefix);
        }

        public async void Start(ScreenScraperBitmapBuffer screenScraper)
        {
            Console.WriteLine("Starting HttpListener...");
            _httpListener.Start();

            while (true)
            {
                Console.WriteLine("Awaiting HttpListener connection...");
                HttpListenerContext listenerContext = await _httpListener.GetContextAsync();

                if (listenerContext.Request.IsWebSocketRequest)
                {
                    Console.WriteLine("Accepting WebSocket connection...");
                    HttpListenerWebSocketContext wsc = await listenerContext.AcceptWebSocketAsync(null);

                    Console.WriteLine("Creating connection, starting reader...");
                    Connection webSocketConnection = new Connection(wsc.WebSocket, screenScraper);
                    webSocketConnection.StartReader();

                    _activeWebSockets.Add(webSocketConnection);
                }
                else
                {
                    listenerContext.Response.StatusCode = 400;
                    listenerContext.Response.Close();
                }
            }
        }



        private HttpListener _httpListener;
        private List<Connection> _activeWebSockets = new List<Connection>();
    }
}
