var Telemetry;
(function (Telemetry) {
    var PerfStore = (function () {
        function PerfStore() {
            this._items = new Array();
        }
        PerfStore.uniqueInstance = null;
        PerfStore.getInstance = function getInstance() {
            if(PerfStore.uniqueInstance == null) {
                PerfStore.uniqueInstance = new PerfStore();
            }
            return PerfStore.uniqueInstance;
        }
        PerfStore.prototype.Reset = function () {
            this._items = new Array();
        };
        PerfStore.prototype.Start = function (id) {
            var item = new PerfStoreItem();
            item.start = Date.now();
            var itemc = this.getCollection(id);
            if(itemc == null) {
                itemc = new PerfStoreItemCollection(id);
                this._items.push(itemc);
            }
            return itemc.Add(item);
        };
        PerfStore.prototype.End = function (id, key, amount) {
            var end = Date.now();
            var itemc = this.getCollection(id);
            if(itemc == null) {
                return;
            }
            itemc.UpdateItem(end, key, amount);
        };
        PerfStore.prototype.getCollection = function (id) {
            for(var i = 0; i < this._items.length; i++) {
                if(this._items[i].Id() == id) {
                    return this._items[i];
                }
            }
            return null;
        };
        PerfStore.prototype.GetItems = function () {
            return this._items;
        };
        return PerfStore;
    })();
    Telemetry.PerfStore = PerfStore;    
    var PerfStoreItemCollection = (function () {
        function PerfStoreItemCollection(id) {
            this._items = new Array();
            this._id = id;
            this._avg = 0;
            this._best = 0;
            this._count = 0;
            this._worst = 0;
            this._avgAmount = 0;
            this._start = Date.now();
        }
        PerfStoreItemCollection.prototype.Id = function () {
            return this._id;
        };
        PerfStoreItemCollection.prototype.Best = function () {
            return this._best;
        };
        PerfStoreItemCollection.prototype.Avg = function () {
            return this._avg;
        };
        PerfStoreItemCollection.prototype.Worst = function () {
            return this._worst;
        };
        PerfStoreItemCollection.prototype.Count = function () {
            return this._count;
        };
        PerfStoreItemCollection.prototype.AvgAmount = function () {
            return this._avgAmount;
        };
        PerfStoreItemCollection.prototype.Start = function () {
            return this._start;
        };
        PerfStoreItemCollection.prototype.UpdateItem = function (end, key, amount) {
            if(this._items.length > 0) {
                var item = this.getItem(key);
                if(item == null) {
                    return;
                }
                item.end = end;
                item.amount = amount;
                var diff = item.end - item.start;
                this._count++;
                if(diff < this._best || this._best == 0) {
                    this._best = diff;
                }
                if(diff > this._worst) {
                    this._worst = diff;
                }
                this._avg = ((diff - this._avg) / this._count) + this._avg;
                this._avgAmount = ((amount - this._avgAmount) / this._count) + this._avgAmount;
            }
        };
        PerfStoreItemCollection.prototype.GetItems = function () {
            return this._items;
        };
        PerfStoreItemCollection.prototype.GetItem = function (i) {
            return this._items[i];
        };
        PerfStoreItemCollection.prototype.getItem = function (key) {
            for(var i = this._items.length - 1; i > -1; i--) {
                if(this._items[i].key == key) {
                    return this._items[i];
                }
            }
            return null;
        };
        PerfStoreItemCollection.prototype.Add = function (item) {
            item.key = this._items.length;
            this._items.push(item);
            return item.key;
        };
        return PerfStoreItemCollection;
    })();
    Telemetry.PerfStoreItemCollection = PerfStoreItemCollection;    
    var PerfStoreItem = (function () {
        function PerfStoreItem() { }
        return PerfStoreItem;
    })();
    Telemetry.PerfStoreItem = PerfStoreItem;    
})(Telemetry || (Telemetry = {}));
